// PatchWorks 1.5 Main GUI File
// This Software is released under the terms of the GPL.

// Graphical User Interface

// deactivated because it's too buggy and not usable (also, some changes in 1.5 may not work in with GUI() )

#include <time.h>

#include "_includes.h"
#include "_defines.h"
#include "_structs.h"

#include "AdminDB.h"
#include "Image.h"
#include "Patchwork.h"
#include "FileSysHelp.h"


int GUI(void)
{
/*
	sDataBase DataBase[MAX_OPEN_DBs] = {0}; // a maximum of MAX_OPEN_DBs Databases kann be open at the same time
	int i,cC,res,err,dbinuse,k=0,dpi;
	char wahl,source[100],target[100],DBangabe[100];
	clock_t starttime, stoptime, time_ms;
	double time_s;


	while(1)
	{
		for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
		printf("\t\t\tProjektarbeit FotoMosaik\n");
		printf("\t\t\t    %s v. %s\n", _APPNAME, _VERSION);
		printf("\t\t\t-_-_-_-_-_-_-_-_-_-_-_-_-");
		for (i=0;i<4;i++) printf("\n");
		printf("Optionen:\n");
		printf("=========");
		printf("\n[1] PseudoPatchwork erstellen");
		printf("\n[2] Patchwork erstellen mit Angabe von Datenbanken");
		printf("\n[3] Datenbank um ein Bild  xy erweitern");
		printf("\n[4] Neue Datenbank erstellen");
		printf("\n[5] Vorhandene Datenbank loeschen");
		//printf("\n[6] Bild xy aus vorhander Datenbank loeschen");
		printf("\n[7] Datenbanken Oeffnen/Schliessen");
		printf("\n[8] Consolen Syntax");
		printf("\n[ESC] Exit");
		wahl = getch(); //esc = 27
		if (wahl == 27) break;

//#############################################################################################################
		if (wahl == '1')//pseudo menue
		{ 

			while (1)
			{
				for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
				printf("PseudoPatchwork erstellen:\n");
				printf("==========================\n");
				printf("\nQuellbild:");
				scanf("%s",source);
				printf("\nZielbild:");
				scanf("%s",target);
				printf("\nAnzahl zu verwendender Farben:");
				scanf("%i",&cC);
				printf("\nAufloesung:");
				scanf("%i",&res);
				
				printf("calculating...\n"); //zeitrechenfkt
				starttime = clock();
				
				err=CreatePseudoPatchwork(source, target, res, res, cC);
				switch (err)
				{
				case 1:printf(eNO_MEMORY);return 1;//not enough memory
				default:printf(err17);break;
				}

				stoptime = clock();
				time_ms = stoptime - starttime;
				time_s = time_ms / 1000.0;
				printf("\nElapsed time: %10.3lf seconds", time_s); //auswertung zeitrechenfkt

				do
				{

					printf("\n Weiteres PseudoPatchwork erstellen J/N");
					wahl = getch();
					//scanf("%c",&wahl);
				}
				while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));




				if ((wahl == 'n')||(wahl == 'N')) break;
			}
		}

//#############################################################################################################

		if (wahl == '2')//patchwork menue
		{
			while (1)
			{
				for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
				printf("Patchwork erstellen:\n");
				printf("====================");
				dbinuse = -1;
				for(i=0; i<MAX_OPEN_DBs; i++)
				{
					if(DataBase[i].inuse == 1)
					{
						dbinuse=i;
						break;
					}
				}
				if( dbinuse == -1 )
				{
					printf("\nKeine geoeffneten Datenbanken verfuegbar");
					printf("\nTaste druecken um ins Hauptmenue zu gelangen");
					getch();
					break;
				
				}
				
				do
				{
					printf("\nPatchwork erstellen? J/N");
					wahl = getch();
				}
				while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));
				if ((wahl == 'n')||(wahl == 'N')) break;
				else 
				{
					printf("\nQuellbild:");
					scanf("%s",source);
					printf("\nZielbild:");
					scanf("%s",target);

					printf("calculating...\n"); //zeitrechenfkt
					starttime = clock();

					err=CreatePatchwork(source, target, DataBase, 1, 0);

					if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von readimage
					{
						printf(err12,err);//readimage failure
						return 1;
					}
					else if ((err>20)&&(err<30))//alle fehler zwischen 10 und 20 stammen von FindFittingPatch
					{
						printf(err25,err);//FindFittingPatch failure
						return 1;
					}
					else if ((err>30)&&(err<40))//alle fehler zwischen 10 und 20 stammen von ReadImage
					{
						printf(err12,err);//ReadImage failure
						return 1;
					}
					else
					{
						switch( err )
						{
						case 2:printf(err26);return 1;// No DB in use
						case 3:printf(eNO_MEMORY);return 1;// not enough memory
						default:printf(err27);
						}

						stoptime = clock();
						time_ms = stoptime - starttime;
						time_s = time_ms / 1000.0;
						printf("\nElapsed time: %10.3lf seconds", time_s); //auswertung zeitrechenfkt
					}
					
				}
				}}
//#############################################################################################################

			if (wahl == '3')//addDB menue
			{
				while (1)
				{
					for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
					printf("Datenbank erstellen:\n");
					printf("====================");
					printf("\nBildname:");
					scanf("%s",source);
					printf("\nDatenbank:");
					scanf("%s",DBangabe);

					err=OpenDB(DataBase, DBangabe); //openDB fehler 1-3 od 11-18
					if ((err>10)&&(err<20)) //alle fehler zwischen 10 und 20 stammen von readindexfile 11-18
					{
						printf(err6,err);//readindex failure
						return 1;
					}
					else
					{
						switch( err )
						{
						case 1:printf(err1_OpenDB);return 1;// To many DBs open
						case 2:printf(eNO_MEMORY);return 1;// not enough memory?
						case 3:printf(eNOT_A_DIR);return 1;//was geht hier
						default: break; //db geoffnet
						}
					}

					err=AddDBItems(source, DataBase, 1);
					if( err == 9 )
					{
						printf(err9_AddDBItem); // not all images added (info only, don't return)
					}
					else if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von readimage
					{
						printf(err12,err);//readimage failure
						return 1;
					}
					else if ((err>20)&&(err<30))//alle fehler zwischen 10 und 20 stammen von ScaleImage
					{
						printf(err13,err);//scaleImage failure
						return 1;
					}
					else if ((err>30)&&(err<40))//alle fehler zwischen 10 und 20 stammen von GetAverageColor
					{
						printf(err14,err);//GetAverageColor failure
						return 1;
					}
					else if ((err>40)&&(err<50))//alle fehler zwischen 10 und 20 stammen von WriteImage
					{
						printf(err15,err);//WriteImage failure
						return 1;
					}
					else
					{


						switch( err )
						{
						case 1:printf(err1_AddDBItem);return 1;//not enough memory
						case 2:printf(err2_AddDBItem);return 1;//illegal database specified
						case 3:printf(err3_AddDBItem);return 1;//DB is full
						case 4:printf(err4_AddDBItem);return 1;//internal error
						default:printf("\nDatenbank wurde erweitert");
						}
					}
					err=SaveDB(DataBase, 0);
					if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von CreateIndexFile
					{
						printf(err7,err);//CreateindexFile failure
						return 1;
					}
					else
					{
						switch (err)
						{
						case 1:printf(err1_SaveDB);return 1;//DB not in use
						case 2:printf(err2_SaveDB);return 1;//no changes to save
						case 3:printf(err3_SaveDB);return 1;//not enough memory?
						case 4:printf(err4_SaveDB);return 1;//directory does not exist?
						case 5:printf(err5_SaveDB);return 1;//could not delete file
						case 6:printf(err6_SaveDB);return 1;//could not create file
						default:printf("\nDatenbank wurde erweitert");
						}
					}
					do
					{

						printf("\n Weiteres Bild einer Datenbank hinzufuegen J/N");
						wahl = getch();
						//scanf("%c",&wahl);
					}
					while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));




					if ((wahl == 'n')||(wahl == 'N')) break;

				}
			}
//#############################################################################################################
			if (wahl == '4')//newDb menue
			{
				while (1)
				{
					for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
					printf("PseudoPatchworkMenue:\n");
					printf("=====================");
					do
					{

						printf("\nNeue Datenbank anlegen? J/N");
						wahl = getch();
						//scanf("%c",&wahl);
					}
					while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));
					if ((wahl == 'n')||(wahl == 'N')) break;
					else 
					{
						printf("\nDatenbankname:");
						scanf("%s",DBangabe);
						while (1)
						{
						printf("\nAufloesung [2-4100]:");
						scanf("%i",&res);
						if ((res>=2)&&(res<=4100)) break;
						}
						while (1)
						{
						printf("DPI[10-16000]:");
						scanf("%i",&dpi);
						if ((dpi>=10)&&(res<=16000)) break;
						}
						err=AddDB(DBangabe, res, res, dpi);

						if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von createIndexFile 11-12
						{
							printf(err7,err);//createIndexFile failure
							return 1;
						}
						else
						{
							switch( err )
							{
							case 1:printf(err1_AddDB);return 1;// illegal resolution
							case 2:printf(err2_AddDB);return 1;// not enough meomory
							case 3:printf(err3_AddDB);return 1;// already exists
							case 4:printf(err4_AddDB);return 1;// couldn't create
							default:printf("\nDatenbank wurde angelegt");
							}
						}


					}

				}
			}
//#############################################################################################################
			if (wahl == '5')//delete DB menue
			{
				while (1)
				{
					for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
					printf("PseudoPatchworkMenue:\n");
					printf("=====================");
					dbinuse = -1;
					for(i=0; i<MAX_OPEN_DBs; i++)
					{
						if(DataBase[i].inuse == 1)
						{
							dbinuse=i;
							break;
						}
					}
					if( dbinuse == -1 ) 
					{
						printf("\nKeine geoeffneten Datenbanken zum loeschen verfuegbar");
						printf("\nTaste druecken um ins Hauptmenue zurueckzukehren");
						getch();
							break;
					}
					else 
					{
						printf("\n\n");
						printf("Geoeffnete Datenbanken:\n");
						for (i=0; i<MAX_OPEN_DBs; i++)
						{

							if(DataBase[i].inuse == 1)
							{
								printf("\nDatenbank [%i] name:%s",i,DataBase[i].path);
								k++;

							}

						}
						printf("\n\n");

					}

					printf("\n[1] Datenbank loeschen");
					printf("\n[ESC] Ins Hauptmenue zurueck");
					wahl = getch();
					if (wahl == 27) break;

					else if (wahl == '1')//Datenbank loeschen
					{

						while (1)
						{
							printf("\nWelche Datenbank soll geloescht werden? [0-9]:");
							scanf("%i",&i);
							if ((i<0)||i>9) printf("\nFalsche eingabe");
							else break;
						}

						err=DeleteDB(DataBase, i);
						if ((err>10)&&(err<20))//alle fehler zwischen 10 und 20 stammen von closeDB 11-18
						{
							printf(err3_CloseDB,err);//closeDB failure code %i
							return 1;
						}
						else
						{
							switch( err )
							{
							case 1:printf(err1_DeleteDB);return 1;// already closed / not in use
							case 2:printf(err2_DeleteDB);return 1;//unsaved changes! save, or set changed=0 to override
							case 3:printf(err3_DeleteDB);return 1;//could not delete (all) items in folder
							case 4:printf(err4_DeleteDB);return 1;//could not remove folder
							default:printf("\nDatenbank wurde geloescht");
							}
						}


						do
						{

							printf("\nWeitere Datenbank loeschen? J/N");

							wahl = getch();
						}
						while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));
						if ((wahl == 'n')||(wahl == 'N')) break;
					}
					else printf("Falsche Eingabe");

					
				}
			}
//#############################################################################################################
			if (wahl == '6')//subDB menue
			{
				while (1)
				{
					for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
					printf("SubDB Menue:\n");
					printf("============");
					printf("\nESC druecken um das testmenue zu verlassen");
					wahl = getch();
					if (wahl == 27) break;
				}
			}
//#############################################################################################################
			if (wahl == '7')//OpenDB und Close DB
			{
				while (1)
				{
					for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
					printf("PseudoPatchworkMenue:\n");
					printf("=====================");

					dbinuse = -1;
					for(i=0; i<MAX_OPEN_DBs; i++)
					{
						if(DataBase[i].inuse == 1)
						{
							dbinuse=i;
							break;
						}
					}
					if( dbinuse == -1 ) printf("\nKeine geoeffneten Datenbanken verfuegbar");
					else 
					{
						printf("\n\n");
						printf("Geoeffnete Datenbanken:\n");
							for (i=0; i<MAX_OPEN_DBs; i++)
							{

								if(DataBase[i].inuse == 1)
								{
									printf("\nDatenbank [%i] name:%s",i,DataBase[i].path);
									k++;

								}

							}
							printf("\n\n");

					}
					printf("\n[1] Neue Datenbank offnen");
					printf("\n[2] Datenbank schliessen");
					printf("\n[ESC] Ins Hauptmenue zurueck");
					wahl = getch();
					if (wahl == 27) break;
					else if (wahl == '1')//Datenbank oeffnen
					{
						for (i=0;i<(MAX_OPEN_DBs-k);i++)
						{
							printf("\nDatenbankname/pfad:");
							scanf("%s",DBangabe);
							//printf("%s",DBangabe);
							err=OpenDB(DataBase, DBangabe); //openDB fehler 1-3 od 11-18
							if ((err>10)&&(err<20)) //alle fehler zwischen 10 und 20 stammen von readindexfile 11-18
							{
								printf(err6,err);//readindex failure

							}
							else
							{
								switch( err )
								{
								case 1:printf(err1_OpenDB);break;// To many DBs open
								case 2:printf(eNO_MEMORY);break ;// not enough memory?
								case 3:printf(eNOT_A_DIR);break ;// could not access directory
								default: printf("Datenbank %s wurde geoeffnet",DBangabe); //db geoffnet
								}
							}
							do
							{
								printf("\nWeitere Datenbank oeffnen? J/N");
								wahl = getch();

							}
							while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));
							if ((wahl == 'n')||(wahl == 'N')) break;


						}
					}
					else if (wahl == '2')//Datenbank schliessen
					{
						
						while (1)
						{
							printf("\nWelche Datenbank soll geschlossen werden? [0-9]:");
							scanf("%i",&i);
							if ((i<0)||i>9) printf("\nFalsche eingabe");
							else break;
						}
						err=CloseDB(DataBase,i );
						if (err==1) printf("\nDatenbank wurde bereits geschlossen");
						else if (err==2) printf("\nDatenbank in benutzung,wenn geschlossen Datenverlust");
						else printf("\nDatenbank wurde erfolgreich geschlossen");
						do
						{

							printf("\nWeitere Datenbank schliessen? J/N");

							wahl = getch();
						}
						while ((wahl !='j') && (wahl !='J') && (wahl !='n') && (wahl !='N'));
						if ((wahl == 'n')||(wahl == 'N')) break;
					}
					else printf("Falsche Eingabe");

				}
			}
//#############################################################################################################
			if (wahl == '8')//help menue
			{ 
				while(1)
				{
					for (i=0;i<18;i++)printf("\n"); //PseudoClearscreen
					printf(help);
					printf("\n\tDruecken sie ESC um wieder in Hauptmenue zu gelangen");
					wahl = getch();
					if (wahl == 27) break;
				}
			}




		}//ende von obersten while

*/
		return 0;


}
